local nkRWardrobeInfo, nkRWardrobe = ...

nkRWardrobe.About = { 
	cbTemplate = {labelinfront = true, labelwidth = 101, fontsize = 13, color = {border = 'ECE4BD', body = '000000', label = 'ECE4BD' }},
	comboTemplate = { color = {border = '666666', body = '000000', label = 'ECE4BD'}, width = 150, fontsize = 13, height = 19 },
	textTemplate = { color = 'ECE4BD', fontsize = 13},
	fldTemplate = { width = 40, height = 20, fontsize = 13, labelwidth = 100, color = { label = 'ECE4BD', border = '666666', body = '000000', focus = '999999' } },
	textHeaderTemplate = { color = 'FFFFFF', fontsize = 16},
	textHeaderShadowTemplate = { color = '000000', fontsize = 16},
}


function nkRWardrobe.About()

	local about = nkUICreateFrame("nkWindow", "nkRWardrobeAbout", nkRWardrobe.UIelements.context)	
	local closeButton = UI.CreateFrame("RiftButton", "nkRWardrobeAbout_closeButton", about:GetContent())
	local addonName = UI.CreateFrame("Text", "nkRWardrobeAbout_addonName", about:GetContent())
	local version = UI.CreateFrame("Text", "nkRWardrobeAbout_version", about:GetContent())
	local writtenBy = UI.CreateFrame("Text", "nkRWardrobeAbout_writteBy", about:GetContent())
	local copyright = UI.CreateFrame("Text", "nkRWardrobeAbout_copyright", about:GetContent())
	local translation = UI.CreateFrame("Text", "nkRWardrobeAbout_translation", about:GetContent())
	local donate1 = UI.CreateFrame("Text", "nkRWardrobeAbout_donate1", about:GetContent())
	local donate2 = UI.CreateFrame("Text", "nkRWardrobeAbout_donate2", about:GetContent())
	local twitter = UI.CreateFrame("Text", "nkRWardrobeAbout_twitter", about:GetContent())
	
	about:SetCloseable(true)
	about:SetDragable(true)
	about:SetTitle(nkRWardrobe.privateVars.addonName)
	about:SetPoint("CENTER", UIParent, "CENTER")		
	about:SetWidth(700)
	about:SetHeight(490)
	about:SetLayer(2)
	
	closeButton:SetPoint("BOTTOMCENTER", about:GetContent(), "BOTTOMCENTER", 0, -20)
	closeButton:SetText(nkRWardrobe.langTexts.btClose)
	
	closeButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
		about:SetVisible(false)
	end, "nkRWardrobeAbout_closeButton_LeftClick")

	addonName:SetPoint("TOPCENTER", about:GetContent(), "TOPCENTER", 0, 20)
	addonName:SetText(string.format(nkRWardrobe.langTexts.about.addonName, nkRWardrobe.privateVars.addonName))
	addonName:SetFontSize(30)
	addonName:SetFontColor(0.906, 0.784, 0.471, 1)
	addonName:SetEffectGlow({ offsetX = 2, offsetY = 2})
	
	version:SetPoint("TOPCENTER", addonName, "BOTTOMCENTER")
	version:SetText(string.format(nkRWardrobe.langTexts.about.version, nkRWardrobe.privateVars.addonVersion))
	version:SetFontSize(18)
	version:SetFontColor(0.906, 0.784, 0.471, 1)
	version:SetEffectGlow({ offsetX = 2, offsetY = 2})

	writtenBy:SetPoint("TOPCENTER", version, "BOTTOMCENTER", 0, 10)
	writtenBy:SetText(nkRWardrobe.langTexts.about.writtenBy)
	writtenBy:SetFontSize(16)
	writtenBy:SetFontColor(1, 1, 1, 1)
	
	copyright:SetPoint("TOPCENTER", writtenBy, "BOTTOMCENTER", 0, 10)
	copyright:SetText(nkRWardrobe.langTexts.about.copyright)
	copyright:SetFontSize(16)
	copyright:SetFontColor(1, 1, 1, 1)
	
	translation:SetPoint("TOPCENTER", copyright, "BOTTOMCENTER", 0, 10)
	translation:SetText(nkRWardrobe.langTexts.about.russian .. ', ' .. nkRWardrobe.langTexts.about.french)
	translation:SetFontSize(16)
	translation:SetFontColor(1, 1, 1, 1)
	
	donate1:SetPoint("TOPCENTER", translation, "BOTTOMCENTER", 0, 20)
	donate1:SetText(nkRWardrobe.langTexts.about.donate1)
	donate1:SetFontSize(20)
	donate1:SetFontColor(0.906, 0.784, 0.471, 1)
	donate1:SetEffectGlow({ offsetX = 2, offsetY = 2})
	
	donate2:SetPoint("TOPCENTER", donate1, "BOTTOMCENTER")
	donate2:SetText(nkRWardrobe.langTexts.about.donate2)
	donate2:SetFontSize(20)
	donate2:SetFontColor(0.906, 0.784, 0.471, 1)
	donate2:SetEffectGlow({ offsetX = 2, offsetY = 2})
	
	twitter:SetPoint("TOPCENTER", donate2, "BOTTOMCENTER", 0, 15)
	twitter:SetText(nkRWardrobe.langTexts.about.twitter)
	twitter:SetFontSize(16)
	twitter:SetFontColor(1, 1, 1, 1)

	return about
	
end
