local nkRWardrobeInfo, nkRWardrobe = ...

nkRWardrobe.Button = { }
nkRWardrobe.Tooltip = { }

function nkRWardrobe.Button()
	
	local button = nil
	local buttonSize = 64 * nkRWSetup.scale / 100
	local iconSize = 48 * nkRWSetup.scale / 100
	local mouseDown = false
	
	local showButtonFlag = false
		
	button = UI.CreateFrame ('Frame', 'nkRWardrobeButton', nkRWardrobe.UIelements.context)
			
	button.border = UI.CreateFrame ('Texture', 'nkRWardrobeButton_Border', button)
	button.border:SetTextureAsync("nkRWardrobe", "ressource/button.png")	
	button.border:SetPoint("TOPLEFT", button, "TOPLEFT")
	button.border:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT")
	button.border:SetLayer(1)
		
	if nkRWSetup.border == false then
		button.border:SetVisible(false)
		button:SetBackgroundColor(0, 0, 0, 1)
		iconSize = buttonSize
	end

	button:SetWidth(buttonSize)
	button:SetHeight(buttonSize)
	button:SetPoint ("TOPRIGHT", UIParent, "TOPRIGHT", nkRWSetup.buttonX, nkRWSetup.buttonY)
	
	button:SetSecureMode('restricted')
	
	button:EventAttach(Event.UI.Input.Mouse.Left.Click, function (self)
		if Inspect.System.Secure() == false then
			if nkRWardrobe.UIelements.tooltip ~= nil then nkRWardrobe.UIelements.tooltip:SetVisible(false) end
			self:ToggleButtons()
		end
	end, "nkRWardrobeButton_LeftClick")
	
	button:EventAttach(Event.UI.Input.Mouse.Right.Down, function (self)
		mouseDown = true
	end, "nkRWardrobeButton_RightDown")
	
	button:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function (self)
		if Inspect.System.Secure() == false and mouseDown == true then
			local mouseData = Inspect.Mouse()
			
			local curdivX = mouseData.x - button:GetLeft()
			local curdivY = mouseData.y - button:GetTop()
			
			nkRWSetup.buttonX = nkRWSetup.buttonX + curdivX
			nkRWSetup.buttonY = nkRWSetup.buttonY + curdivY
			
			button:SetPoint ("TOPRIGHT", UIParent, "TOPRIGHT", nkRWSetup.buttonX, nkRWSetup.buttonY)
		end
	end, "nkRWardrobeButton_CursorMove")				
	
	button:EventAttach(Event.UI.Input.Mouse.Right.Up, function (self)
		mouseDown = false 			
	end, "nkRWardrobeButton_RightUp")			
	
	button:EventAttach(Event.UI.Input.Mouse.Right.Upoutside , function ()
		mouseDown = false
	end, "nkRWardrobeButton_RightUpOutside")			
	
	button:EventAttach(Event.UI.Input.Mouse.Cursor.In, function (self)
		if Inspect.System.Secure() == false then
			self.ttCounter = 0
			self:ShowHelp()
		end
	end, "nkRWardrobeButton_CursorIn")
	
	button:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function (self)
		if Inspect.System.Secure() == false and 0 == self.ttCounter then
			self.ttCounter = nil
			if nkRWardrobe.UIelements.tooltip ~= nil then nkRWardrobe.UIelements.tooltip:SetVisible(false) end
		end
	end, "nkRWardrobeButton_CursorOut")			

	local iconPath = nkRWSetup.sets[nkRWSetup.activeSet].icon
	if tonumber(nkRWSetup.sets[nkRWSetup.activeSet].icon) ~= nil then iconPath = 'ressource/'.. nkRWardrobe.privateVars.calling .. nkRWSetup.sets[nkRWSetup.activeSet].icon .. '.png' end		
	
	local iconType = 'Rift'
	if string.find (iconPath, 'ressource/') ~= nil then iconType = 'nkRWardrobe' end
	
	button.icon = UI.CreateFrame ('Texture', 'nkRWardrobeButtonIcon', button)
	button.icon:SetTextureAsync(iconType, iconPath)
	button.icon:SetWidth(iconSize)
	button.icon:SetHeight(iconSize)
	button.icon:SetPoint("CENTER", button, "CENTER")
	button.icon:SetSecureMode('restricted')
	button.icon:SetLayer(2)
	
	local from, object, to, x, y = nil, button, nil, 0, 0
	
	if nkRWSetup.open == 'bottom' then
		from, to = "TOPLEFT", "BOTTOMLEFT"
		if nkRWSetup.border == false then y = -5 end
	elseif nkRWSetup.open == 'top' then	
		from, to = "BOTTOMLEFT", "TOPLEFT"
		if nkRWSetup.border == false then y = 5 end
	elseif nkRWSetup.open == 'left' then
		from, to = "CENTERRIGHT", "CENTERLEFT"
		if nkRWSetup.border == false then x = -5 end
	elseif nkRWSetup.open == 'right' then
		from, to = "CENTERLEFT", "CENTERRIGHT"
		if nkRWSetup.border == false then x = 5 end
	end	
	
	local counter = 1
	if subButtons == nil then subButtons = {} end
	
	for k, v in pairs (nkRWSetup.sets) do

		local subIconPath = v.icon
		if (subIconPath == nil) then subIconPath = 'ressource/equipEmptyhandmain.png'; end
		
		local subIconType = 'Rift'
				
		if string.find (subIconPath, 'ressource/') ~= nil then subIconType = 'nkRWardrobe' end
		
		local subButton = nil
	
		if subButtons[counter] == nil then
	
			subButton = UI.CreateFrame ('Frame', 'nkRWardrobeButton', nkRWardrobe.UIelements.context)
			
			subButton.border = UI.CreateFrame("Texture", 'nkRWardrobeSubButton' .. k, subButton)
			subButton.border:SetTextureAsync('nkRWardrobe', 'ressource/button.png')
			subButton.border:SetLayer(1)
			subButton.border:SetPoint("TOPLEFT", subButton, "TOPLEFT")
			subButton.border:SetPoint("BOTTOMRIGHT", subButton, "BOTTOMRIGHT")
			
			if nkRWSetup.border == false then
				subButton.border:SetVisible(false)
			end
			
			subButton:SetWidth(buttonSize)
			subButton:SetHeight(buttonSize)
			subButton:SetPoint(from, object, to, x, y)			
			subButton:SetVisible(false)
			subButton:SetSecureMode ('restricted')
						
			subButton.icon = UI.CreateFrame ('Texture', 'nkRWardrobeButton' .. k .. 'Icon', subButton)
			subButton.icon:SetTextureAsync(subIconType, subIconPath)
			subButton.icon:SetWidth(iconSize)
			subButton.icon:SetHeight(iconSize)
			subButton.icon:SetPoint("CENTER", subButton, "CENTER")
			subButton.icon:SetSecureMode('restricted')
			subButton.icon:SetLayer(2)
			
			subButton:EventAttach(Event.UI.Input.Mouse.Cursor.In, function (self)
				self.ttCounter = k
				button:ShowTooltip(k)
			end, "nkRWardrobeSubButton_".. k .. "CursorIn")
			
			subButton:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function (self)
				if k == self.ttCounter then
					self.ttCounter = nil
					if tooltip ~= nil then tooltip:SetVisible(false) end
				end
			end, "nkRWardrobeSubButton_".. k .. "CursorOut")
			
			table.insert (subButtons, subButton)
		else
			subButton = subButtons[counter]
			subButton:SetPoint(from, object, to, x, y)
			subButton:SetVisible (false)
			subButton.icon:SetTextureAsync(subIconType, subIconPath)
		end
		
		subButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function (self)
			if Inspect.System.Secure() == false then
				nkRWSetup.activeSet = k
				nkRWardrobe.wearEquip(k)				
				button.icon:SetTexture (subIconType, subIconPath)
				button:ToggleButtons()
				if nkRWardrobe.UIelements.tooltip ~= nil then nkRWardrobe.UIelements.tooltip:SetVisible(false) end
			end
		end, "nkRWardrobeSubButton_".. k .. "LeftClick")
		
		subButton:EventMacroSet(Event.UI.Input.Mouse.Left.Click, string.format ('role %d', v.role))
				
		object = subButton
		counter = counter + 1
		
	end
	
	for idx = counter, 1, #subButtons do
		subButtons[idx]:SetVisible(false)
	end
	
	function button:ToggleButtons()

		local flag = showButtonFlag		
		if flag == true then flag = false else flag = true end
		showButtonFlag = flag

		for idx = 1, #nkRWSetup.sets, 1 do
			if subButtons[idx] ~= nil then subButtons[idx]:SetVisible(flag) end
		end

	end

	function button:ShowTooltip(counter)

		local set = nkRWSetup.sets[counter]
		if set == nil then return end

		local from, to = "BOTTOM", "TOP"
		
		if nkRWSetup.buttonY < 100 then from = "TOP" end
		
		if nkRWSetup.buttonX > -250 then 
			from = from .. 'RIGHT'
			to = to .. 'LEFT'
		else
			from = from .. 'LEFT'
			to = to .. 'RIGHT'
		end
			
		if nkRWardrobe.UIelements.tooltip == nil then nkRWardrobe.UIelements.tooltip = nkUICreateFrame('nkTooltip', 'nkRWardrobeTooltip', nkRWardrobe.UIelements.tooltipContext ) end
		
		local lines = { { text = nkRWardrobe.langTexts.fldRole .. ': ' .. set.role }, { text = '', height = 8, }, { text = nkRWardrobe.langTexts.equipTooltip } }
		
		nkRWardrobe.UIelements.tooltip:SetTitle(set.name)		
		nkRWardrobe.UIelements.tooltip:ClearAll()
		nkRWardrobe.UIelements.tooltip:SetPoint(from, subButtons[counter],  to)
		nkRWardrobe.UIelements.tooltip:SetLines(lines)
		nkRWardrobe.UIelements.tooltip:SetVisible(true)
		
	end

	function button:ShowHelp()
	
		local from, to = "BOTTOM", "TOP"
		
		if nkRWSetup.buttonY < 100 then from = "TOP" end
		
		if nkRWSetup.buttonX > -250 then 
			from = from .. 'RIGHT'
			to = to .. 'LEFT'
		else
			from = from .. 'LEFT'
			to = to .. 'RIGHT'
		end
							
		if nkRWardrobe.UIelements.tooltip == nil then nkRWardrobe.UIelements.tooltip = nkUICreateFrame('nkTooltip', 'nkRWardrobeTooltip', nkRWardrobe.UIelements.tooltipContext ) end
			
		local lines = { { text = nkRWardrobe.langTexts.helpLine1 }, { text = nkRWardrobe.langTexts.helpLine3 } }
		
		nkRWardrobe.UIelements.tooltip:SetTitle(nkRWardrobe.langTexts.helpTitle)
		nkRWardrobe.UIelements.tooltip:ClearAll()
		nkRWardrobe.UIelements.tooltip:SetPoint(from, button,  to)
		nkRWardrobe.UIelements.tooltip:SetLines(lines)
		nkRWardrobe.UIelements.tooltip:SetVisible(true)

	end

	function button:Update()
	
		buttonSize = 64 * nkRWSetup.scale / 100
	
		if nkRWSetup.border == true then
			iconSize = 48 * nkRWSetup.scale / 100
		else
			iconSize = buttonSize
		end

		button:SetWidth(buttonSize)
		button:SetHeight(buttonSize)
		
		button.border:SetVisible(nkRWSetup.border)
		button.icon:SetWidth(iconSize)
		button.icon:SetHeight(iconSize)
		
		for idx = 1, #subButtons, 1 do
			subButtons[idx].border:SetVisible(nkRWSetup.border)
			subButtons[idx].icon:SetWidth(iconSize)
			subButtons[idx].icon:SetHeight(iconSize)
		end
	
	end
	
	function button:ReAlign()
	
		local from, object, to, x, y = nil, button, nil, 0, 0
	
		if nkRWSetup.open == 'bottom' then
			from, to = "TOPLEFT", "BOTTOMLEFT"
			if nkRWSetup.border == false then y = -5 end
		elseif nkRWSetup.open == 'top' then	
			from, to = "BOTTOMLEFT", "TOPLEFT"
			if nkRWSetup.border == false then y = 5 end
		elseif nkRWSetup.open == 'left' then
			from, to = "CENTERRIGHT", "CENTERLEFT"
			if nkRWSetup.border == false then x = -5 end
		elseif nkRWSetup.open == 'right' then
			from, to = "CENTERLEFT", "CENTERRIGHT"
			if nkRWSetup.border == false then x = 5 end
		end	
		
		for idx = 1, #subButtons, 1 do
			subButtons[idx]:ClearAll()
			subButtons[idx]:SetPoint(from, object, to, x, y)
			object = subButtons[idx]
		end
		
	end
	
	return button
	
end